// This is the builder.sce
// must be run from this directory
mode(-1);

//Nom de la librairie Scilab

LINLIBRARY = 'CG_LAB.a'
WINLIBRARY = 'CG_LAB.lib'
DLLNAME    = 'CG_LAB.dll'

INTERFACE_FILE = 'CG_LAB_gateway.o'

//Fichiers objets  compiler pour linux
COBJFILES = 'intconvex_hull.o '+..
            'intDelaunay_2d.o '+..
            'intDelaunay_3d.o '+..
            'intDelaunay_nd.o '+..
            'intConstrained_Delaunay.o '+..
            'intDelaunay_mesher.o '
// here add your interfaces.o's files to be compiled


//Fichiers objet pour Windows
COBJFILESWIN = strsubst(COBJFILES,'.o','.obj')

INTERFACE_FILE_WIN= strsubst(INTERFACE_FILE,'.o','.obj')


disp('Making all in CGLAB-0.9 contribution');
disp('be patient, this may take a while');


// Generic part to get the absolute contribution path
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1
	l=strindex(nams(k),'builder.sce');
	if l<>[] then
		DIR=part(nams(k),1:l($)-1);
		break
	end
end

//---------------------------------------------------------------------
// Under Unix and Linux systems
//---------------------------------------------------------------------
if ~MSDOS then
	if part(DIR,1)<>'/' then
		DIR=getcwd()+'/'+DIR
	end

	// Path of the C-source files directory
	SRC=DIR+'src/'
	// Create Makefile for source files
	u=file('open',SRC+'Makefile','unknown')
	write(u,['#----------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#----------------------------------------------------------------------'
		'SCIDIR = '+SCI
		'LIBRARY = '+LINLIBRARY // Object file library
		'OBJSF = '//Fortran objects (do not include interface)
		'OBJSC = '+COBJFILES //C objects (do not include interface)
		'include '+SCI+'/Makefile.incl'
		'CFLAGS = $(CC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines '
		'FFLAGS = $(FC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines '
		'include '+SCI+'/routines/Make.lib'
		'all :: '+INTERFACE_FILE],'(a)') // Interface object
	file('close',u)
	cmd_make='make'

	// Building libCG-LAB library
	OLD=getcwd();
 	chdir(SRC+'libCG-LAB/')
	disp('Compiling libCG-LAB library.');
	execstr('exec builder.sce');
	chdir(OLD)
else
//---------------------------------------------------------------------
// Under Windows systems
//---------------------------------------------------------------------
	if part(DIR,2)<>':' then
		DIR=getcwd()+'\'+DIR
	end
	// Path of the macros directory
	MACROS=DIR+'macros\'

	// Path of the C-source files directory
  	SRC=DIR+'src\'

	// Scilab path under Windows
  	SCI_WIN=strsubst(SCI,'/','\')
	// Create Makefile
	disp('Creating Makefile')
  	u=file('open',SRC+'Makefile','unknown')
  	tab=code2str(-40)

	write(u,['#---------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#---------------------------------------------------------------------'
  		'SCIDIR1 = ""'+SCI_WIN+'""'
  		'SCIDIR = ""'+SCI_WIN+'""'
  		'DUMPEXTS = ""'+SCI_WIN+'\bin\dumpexts.exe""'
  		'CGLABLIB= ""'+SRC+'libCG-LAB\src\libCGLAB.lib""' // libcglab library
  		'SCIIMPLIB = ""'+SCI_WIN+'\bin\LibScilab.lib""'
  		'LIBRARY = '+WINLIBRARY // Object file library
  		'OBJSF = ' // Fortran objects files
  		'OBJSC = '+COBJFILESWIN'+'CG_LAB_gateway.obj'
  		'include ..\Makefile.incl.mak'

  		'CFLAGS = $(CC_OPTIONS) -DFORDLL -I""'+SCI_WIN+'\routines"" '
  		'FFLAGS = $(FC_OPTIONS) -DFORDLL -I""'+SCI_WIN+'\routines"" -I""C:\PROGRA~1\MICROS~2\VC98\include"" '
  		' '
  		'all :: '+DLLNAME // Dynamic library
  		' '
  		DLLNAME+' : $(OBJSC)'
  		tab+'@$(DUMPEXTS) -o ""$*.def"" ""$*.dll"" $**'
  		tab+'@$(LINKER) $(LINKER_FLAGS) $(OBJSC) $(OBJSF) $(CGLABLIB) $(SCIIMPLIB) $(XLIBSBIN)'+..
  		' $(TERMCAPLIB) /nologo /dll /out:""$*.dll"" /implib:""$*.ilib"" '+..
  		'/def:""$*.def""'
  		'distclean ::'
  		tab+'@del *.obj';
  		tab+'@del *.dll'
  		tab+'@del *.ilib'
  		tab+'@del *.def'],'(a)');
  		file('close',u)

  		cmd_make='nmake /f Makefile'


  		// Building libCG-LAB library
		OLD=getcwd();
  		chdir(SRC+'\libCG-LAB\')
		disp('Compiling libCG-LAB library.');
		execstr('exec builder.sce');
		chdir(OLD)
end

OLD=getcwd();
chdir(SRC)
disp('Compiling Interfaces library')
unix_s(cmd_make)
disp('Interfaces library Compiled')
chdir(OLD);
