// Copyright (c) 2005  INRIA Sophia-Antipolis (France).

// All rights reserved.

//

// This file is part of CG-LAB; you can redistribute it and/or

// modify it under the terms of the GNU Lesser General Public License as

// published by the Free Software Foundation; version 2.1 of the License.

// See the file LICENSE.LGPL distributed with CG-LAB.

//

// Licensees holding a valid commercial license may use this file in

// accordance with the commercial license agreement provided with the software.

//

// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE

// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

//

// $Id: CG_LAB_gateway.c,v 1.6 2005/12/02 10:35:34 nmeskini Exp $

// $URL$

//

// Author(s)     : Naceur Meskini



#include "mex.h"



static int direct_gateway(char *fname,void F(void)) { F();return 0;};



extern Gatefunc int_convex_hull_2;



extern Gatefunc int_delaunay_triangulation_2;

extern Gatefunc int_dt2_get_connectivity;

extern Gatefunc int_dt2_insert_points;

extern Gatefunc int_dt2_remove_points;

extern Gatefunc int_dt2_delete;

extern Gatefunc int_delaunay_triangulation_3;

extern Gatefunc int_dt3_get_connectivity;

extern Gatefunc int_dt3_insert_points;

extern Gatefunc int_dt3_remove_points;

extern Gatefunc int_dt3_delete;

extern Gatefunc int_delaunay_triangulation_n;

extern Gatefunc int_dtn_get_connectivity;

extern Gatefunc int_dtn_insert_points;

extern Gatefunc int_dtn_delete;

extern Gatefunc int_convex_hull_3;

extern Gatefunc int_constraind_delaunay_2;

extern Gatefunc int_cdt2_get_connectivity;

extern Gatefunc int_cdt2_get_coord;

extern Gatefunc int_cdt2_insert_points;

extern Gatefunc int_cdt2_remove_points;

extern Gatefunc int_cdt2_insert_constraints;

extern Gatefunc int_cdt2_remove_constraints;

extern Gatefunc int_cdt2_delete;

extern Gatefunc int_mesh_2;

extern Gatefunc int_mesh2_get_connectivity;

extern Gatefunc int_mesh2_get_coord;

extern Gatefunc int_mesh2_refine;

extern Gatefunc int_mesh2_set_seeds;

extern Gatefunc int_mesh2_delete;

static GenericTable Tab[]={

{(Myinterfun)sci_gateway,int_convex_hull_2,"%cgal_convex_hull_2"},

{(Myinterfun)sci_gateway,int_delaunay_triangulation_2,"%cgal_delaunay_2"},

{(Myinterfun)sci_gateway,int_dt2_get_connectivity,"%cgal_dt2_get_connectivity"},

{(Myinterfun)sci_gateway,int_dt2_insert_points,"%cgal_dt2_insert_points"},

{(Myinterfun)sci_gateway,int_dt2_remove_points,"%cgal_dt2_remove_points"},

{(Myinterfun)sci_gateway,int_dt2_delete,"%cgal_dt2_delete"},

{(Myinterfun)sci_gateway,int_delaunay_triangulation_3,"%cgal_delaunay_3"},

{(Myinterfun)sci_gateway,int_dt3_get_connectivity,"%cgal_dt3_get_connectivity"},

{(Myinterfun)sci_gateway,int_dt3_insert_points,"%cgal_dt3_insert_points"},

{(Myinterfun)sci_gateway,int_dt3_remove_points,"%cgal_dt3_remove_points"},

{(Myinterfun)sci_gateway,int_dt3_delete,"%cgal_dt3_delete"},

{(Myinterfun)sci_gateway,int_delaunay_triangulation_n,"%cgal_delaunay_n"},

{(Myinterfun)sci_gateway,int_dtn_get_connectivity,"%cgal_dtn_get_connectivity"},

{(Myinterfun)sci_gateway,int_dtn_insert_points,"%cgal_dtn_insert_points"},

{(Myinterfun)sci_gateway,int_dtn_delete,"%cgal_dtn_delete"},

{(Myinterfun)sci_gateway,int_convex_hull_3,"%cgal_convex_hull_3"},

{(Myinterfun)sci_gateway,int_constraind_delaunay_2,"%cgal_constraind_delaunay_2"},

{(Myinterfun)sci_gateway,int_cdt2_get_connectivity,"%cgal_cdt2_get_connectivity"},

{(Myinterfun)sci_gateway,int_cdt2_get_coord,"%cgal_cdt2_get_coord"},

{(Myinterfun)sci_gateway,int_cdt2_insert_points,"%cgal_cdt2_insert_points"},

{(Myinterfun)sci_gateway,int_cdt2_remove_points,"%cgal_cdt2_remove_points"},

{(Myinterfun)sci_gateway,int_cdt2_insert_constraints,"%cgal_cdt2_insert_constraints"},

{(Myinterfun)sci_gateway,int_cdt2_remove_constraints,"%cgal_cdt2_remove_constraints"},

{(Myinterfun)sci_gateway,int_cdt2_delete,"%cgal_cdt2_delete"},

{(Myinterfun)sci_gateway,int_mesh_2,"%cgal_mesh_2"},

{(Myinterfun)sci_gateway,int_mesh2_get_connectivity,"%cgal_mesh2_get_connectivity"},

{(Myinterfun)sci_gateway,int_mesh2_get_coord,"%cgal_mesh2_get_coord"},

{(Myinterfun)sci_gateway,int_mesh2_refine,"%cgal_mesh2_refine"},

{(Myinterfun)sci_gateway,int_mesh2_set_seeds,"%cgal_mesh2_set_seeds"},

{(Myinterfun)sci_gateway,int_mesh2_delete,"%cgal_mesh2_delete"},

};





int C2F(CG_LAB_gateway)()

{

	Rhs=Max(0, Rhs);

	(*(Tab[Fin-1].f))(Tab[Fin-1].name,Tab[Fin-1].F);

	return 0;

}

